﻿Public Class Form1

    'cria a exceção personalizada herdando de Exception
    Public Class ArmstrongException
        Inherits Exception
        Public Sub New()
        End Sub
    End Class

    Private Sub btnVerifica_Click(sender As Object, e As EventArgs) Handles btnVerifica.Click
        Dim numero, soma, temp, resto, nudig As Double
        soma = 0

        Try
            numero = Convert.ToDouble(txtNumero.Text)
            temp = numero
            nudig = contaNumeroDigitos(temp)

        Catch ovex As OverflowException
            MessageBox.Show("Erro de overflow :" + ovex.Message)
            Return
        Catch ex As Exception
            MessageBox.Show("Erro :" + ex.Message)
            Return
        End Try

        While Not (temp = 0)
            resto = temp Mod 10
            soma = soma + Math.Pow(resto, nudig)
            temp = Int(temp / 10)
        End While

        Try
            If (numero = soma) Then
                lstArmstrong.Items.Add(numero)
                txtNumero.Clear()
            Else
                Throw New ArmstrongException()
                lstArmstrong.Items.Clear()
            End If
        Catch ex As Exception
            MsgBox("Exceção :Este número não é um Número de Armstrong", MsgBoxStyle.Critical, "ArmStrongException")
        End Try

    End Sub
    Private Shared Function contaNumeroDigitos(numero As Integer) As Integer
        Dim numdigitos As Integer = 0
        Do
            numero = numero \ 10
            numdigitos += 1
        Loop While numero > 0
        Return numdigitos
    End Function
End Class
