﻿Public Class form1

    Dim numero As Integer

    'cria a exceção personalizada herdando de Exception
    Public Class ArmstrongException
        Inherits Exception
        Public Sub New()
        End Sub
    End Class

    Private Sub btnVerificaNumeroArmstrong_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVerificaNumeroArmstrong.Click

        Dim a, b, c, soma As Integer
        'converte o valor para numerico
        numero = Val(txtNumero.Text)

        If numero < 100 Or numero > 999 Then
            MessageBox.Show("Numero deve estar entre 100 e 999")
            Return
        End If

        a = numero \ 100 'divide o valor do numero por 100 e toma a parte real
        b = (numero Mod 100) \ 10 'Usa a função mod para remover o primeiro numero e dividir por 10
        c = numero Mod 10 'Pega o último numero usando Mod
        'soma o número elevento aos digitos (no nosso caso apenas 3)
        soma = a * a * a + b * b * b + c * c * c

        'verifica se o numero é de armstrong e lança a exceção se for o caso
        Try
            'se for numero armstrong então inclui no listbox
            If soma = numero Then
                lstArmstrong.Items.Add(numero)
                txtNumero.Clear()
            Else
                'lança exceção
                Throw New ArmstrongException
            End If
        Catch ex As ArmstrongException
            MsgBox("Exceção :: Este número não é um Número de Armstrong", MsgBoxStyle.Critical, "ArmStrongException")
        End Try
    End Sub

    Private Sub btnEncerrar_Click(sender As Object, e As EventArgs) Handles btnEncerrar.Click
        Me.Close()
    End Sub
End Class
